/**
 * 多图片上传组件提交辅助工具
 * @param PictureUploaderList
 * @param callback
 */
;var multiUploaderSubmitter = function (pictureUploaderArray) {
    var submitter = {pictureUploaderArray: pictureUploaderArray};
    submitter.submit = function (callback) {
        localStorage.waitUploadCount = 0;
        localStorage.hasError = false;
        localStorage.uploadedPictureMap = "{}";
        
        if (pictureUploaderArray.length > 0) {
            localStorage.waitUploadCount = pictureUploaderArray.length;
            for (var i = 0; i < pictureUploaderArray.length; i++) {
                var pictureUploader = pictureUploaderArray[i];
                pictureUploader.upload(function (result, ownId) {
                    localStorage.waitUploadCount = (parseInt(localStorage.waitUploadCount) - 1) + '';
                    if (!result.data) return false;
                    var map=JSON.parse(localStorage.uploadedPictureMap);
                    map[ownId] = result.data;
                    localStorage.uploadedPictureMap = JSON.stringify(map);
                }, function (result) {
                    plus.nativeUI.alert(result.message);
                    localStorage.hasError = true;
                    localStorage.waitUploadCount = (parseInt(localStorage.waitUploadCount) - 1) + '';
                });
            }
        }
        //不断轮询图片是否已经上传完成
        var interval = setInterval(function () {
            if (localStorage.hasError === 'true') {
                clearInterval(interval);
                return false;
            }
            if (parseInt(localStorage.waitUploadCount) <= 0) {
                clearInterval(interval);
                var uploadedPictureMap = JSON.parse(localStorage.uploadedPictureMap);
                callback(uploadedPictureMap);
            }
        }, 200);
    };
    return submitter;
};