;
var Sharer = {
	shareServiceList: {},
	//获取分享通道
	getShareChannels: function() {
		var channels = [{
			id: "weixin",
			name: "发送给微信好友",
			extend: "WXSceneSession"
		}, {
			id: "weixin",
			name: "分享到微信朋友圈",
			extend: "WXSceneTimeline"
		}];
		return channels;
	},
	//获取分享服务列表
	getShareServices: function() {
		if(Sharer.shareServiceList.length > 0)
			return Sharer.shareServiceList;

		plus.share.getServices(function(s) {
			if(s && s.length > 0) {
				for(var i = 0; i < s.length; i++) {
					var t = s[i];
					Sharer.shareServiceList[t.id] = t;
				}
			}
		}, function() {
			console.log("获取分享服务列表失败");
		});
		return Sharer.shareServiceList;
	},
	//发送分享
	sendLinkShareMessage: function(shareService, title, url, content, extend) {
		var msg = {
			extra: {
				scene: extend
			}
		};
		msg.href = url;
		msg.title = title;
		msg.content = content || "";
		/*if(~share.id.indexOf('weibo')) {
			msg.content += "；体验地址：http://www.dcloud.io/hellomui/";
		}*/
		msg.thumbs = ["../images/LOGO.png"];
		shareService.send(msg, function() {
			console.log("分享到\"" + shareService.description + "\"成功！ ");
		}, function(e) {
			console.log("分享到\"" + shareService.description + "\"失败: " + e.code + " - " + e.message);
		});
	},
	linkShare: function(title, url, content) {
		var channels = this.getShareChannels();

		var bts = [];
		for(var i = 0; i < channels.length; i++) {
			bts.push({
				"title": channels[i].name
			});
		}
		console.log(JSON.stringify(bts));
		plus.nativeUI.actionSheet({
			title: "链接分享",
			cancel: "取消",
			buttons: bts
		}, function(e) {
			var i = e.index;
			if(i > 0) {
				var channel = channels[i - 1];
				var s_id = channel.id;
				var shareServiceList = Sharer.getShareServices();

				window.setTimeout(function() {
					var shareService = shareServiceList[s_id];
					if(shareService) {
						if(shareService.authenticated) {
							Sharer.sendLinkShareMessage(shareService, title, url, content, channel.extend);
						} else {
							shareService.authorize(function() {
								Sharer.sendLinkShareMessage(shareService, title, url, content, channels[i - 1].extend);
							}, function(e) {
								console.log("认证授权失败：" + e.code + " - " + e.message);
							});
						}
					} else {
						//							mui.toast("无法获取分享服务，请检查manifest.json中分享插件参数配置，并重新打包")
						mui.toast("无法获取分享服务！")
					}
				}, 500);
			}
		});
	}

};