/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.yzmnumber = loginInfo.yzmnumber || '';

		if(loginInfo.account.length < 1) {
			return callback('账号不能为空');
		}

		if(loginInfo.yzmnumber.length < 6) {
			return callback('验证码最短为 6 个字符');
		}

	};

	/**
	 * 参数较验
	 *
	 * */
	owner.asdf = function() {
		stop: false, //倒计时
		//验证码倒计时
		owner.code = function(tel, yzmclick, type) {
			var that = this,
				tel = $.trim(tel);
			if(!this.phone(tel, 'userTel')) return false;
			if(true == that.stop) return false; //防止重复点击
			that.stop = true;

			var yzmclick = $("#" + yzmclick);
			yzmnumber.attr("disabled", true).text("正在发送");
			var _no = 60;
			var time = setInterval(function() {
				_no--;
				yzmnumber.text(_no + "秒后重发");
				if(_no == 0) {
					//yzmnumber.attr("disabled", false).text("获取验证码");
					yzmnumber.removeAttr('disabled').text("重新获取验证码");
					that.stop = false;
					_no = 60;
					clearInterval(time);
				}
			}, 1000);

			var url = "";
			$.post(url, {
				toNumber: tel,
				type: type
			}, function(result) {
				mui.toast(result.info);
				if(200 != result.status) {
					yzmnumber.removeAttr('disabled').text("获取验证码");
					that.stop = false;
					_no = 60;
					clearInterval(time);
				}
			}, 'json');
		}
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		//真实姓名
		regInfo.realName = regInfo.realName || '';
		//用户名信息
		regInfo.accountName = regInfo.accountName || '';

		//手机号码信息
		regInfo.moblie = regInfo.moblie || '';
		//验证码信息
		regInfo.yzmnumber = regInfo.yzmnumber || '';
		//密码信息
		regInfo.password = regInfo.password || '';
		//推荐人工号
		regInfo.artificialNumber = regInfo.artificialNumber || '';
//		//账户名称输入规范
//		if(regInfo.accountName.length < 6) {
//			return callback('账户名称最短需要6个字符！');
//		}
		//真实姓名输入规范
//		if(regInfo.realName.length == 0) {
//			return callback('真实姓名不能为空');
//		}
		//手机号码输入规范	
		if(regInfo.moblie.length < 11) {
			return callback('手机号码输入不合法！');
		}
		//密码输入规范
		if(regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符！');
		}
		//推荐码输入规范
		if(regInfo.artificialNumber.length == 0) {
			return callback('推荐码不能为空');
		}

		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return(email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetyzmnumber = function(email, callback) {
		callback = callback || $.noop;
		if(!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
	/**
	 * 获取本地是否安装客户端
	 **/
	owner.isInstalled = function(id) {
		if(id === 'qihoo' && mui.os.plus) {
			return true;
		}
		if(mui.os.android) {
			var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch(e) {}
		} else {
			switch(id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
		}
	}
}(mui, window.app = {}));