var global = {};

//测试打包参数
//global.service_url = "http:/172.28.227.254:8068/rest";
//global.service_url = "http://172.28.227.131:8068/rest"
//global.service_url = "http://172.28.227.141:8085/saas";
//global.service_url = "http://172.28.227.189:8085/saas";
//global.service_url = "http://172.28.227.193:8068/rest";
//global.service_url = "http://172.28.227.97:8085/saas";
//global.service_url = "http://test.qianzhousoft.com/rest";
//global.isDebug = true;
//正式打包参数
global.service_url = "https://www.qianzhousoft.com/saas";
global.isDebug=false;

global.getRequestUrl = function(path) {
	return global.service_url + path;
};

global.log = function(message) {
	if(global.isDebug)
		console.log(message);
};

//当前用户信息
global.userInfo = {
	setAppId: function(value) {
		plus.storage.setItem("appId", value);
	},
	getAppId: function() {
		return plus.storage.getItem("appId");
	},
	setClientId: function(value) {
		plus.storage.setItem("clientId", value);
	},
	getClientId: function() {
		return plus.storage.getItem("clientId");
	},
	setUserId: function(value) {
		plus.storage.setItem("userId", value);
	},
	getUserId: function() {
		return plus.storage.getItem("userId");
	},
	setRealName: function(value) {
		plus.storage.setItem("realName", value);
	},
	getRealName: function() {
		return plus.storage.getItem("realName");
	},
	setAccountName: function(value) {
		plus.storage.setItem("accountName", value);
	},
	getAccountName: function() {
		return plus.storage.getItem("accountName");
	},
	setAccountType: function(value) {
		plus.storage.setItem("accountType", value);
	},
	getAccountType: function() {
		return plus.storage.getItem("accountType");
	},
	setLoginToken: function(value) {
		plus.storage.setItem("loginToken", value);
	},
	getLoginToken: function() {
		return plus.storage.getItem("loginToken");
	},
	setMobile: function(value) {
		plus.storage.setItem("mobile", value);
	},
	getMobile: function() {
		return plus.storage.getItem("mobile");
	},
	setPost: function(value) {
		plus.storage.setItem("post", value);
	},
	getPost: function() {
		return plus.storage.getItem("post");
	},
	setEmail: function(value) {
		plus.storage.setItem("email", value);
	},
	getEmail: function() {
		return plus.storage.getItem("email");
	},
	setWorkNumber: function(value) {
		plus.storage.setItem("workNumber", value);
	},
	getWorkNumber: function() {
		return plus.storage.getItem("workNumber");
	},
	setAvatar: function(value) {
		plus.storage.setItem("avatar", value);
	},
	getAvatar: function() {
		return plus.storage.getItem("avatar");
	},
	setSessionId: function(value) {
		plus.storage.setItem("sessionId", value);
		plus.navigator.setCookie(global.service_url + "/", value);
		// alert("保存SessionId："+value);
	},
	getSessionId: function() {
		return plus.storage.getItem("sessionId");
	},
	setDeviceToken: function(value) {
		if(value != null)
			plus.storage.setItem("deviceToken", value + "");
	},
	getDeviceToken: function() {
		return plus.storage.getItem("deviceToken");
	},
	setAddress: function(address) {
		plus.storage.setItem("currentAddress", address);
	},
	getAddress: function() {
		return plus.storage.getItem("currentAddress");
	},
	setPermission: function(key, value) {
		plus.storage.setItem(key, value);
	},
	clearAllPermission: function() {
		for(var key in appPermissionKeys) {
			plus.storage.removeItem(key);
		}
	},
	hasPermission: function(key) {
		return(plus.storage.getItem(key) || "") === "1";
	},
	clear: function() {
		//		plus.storage.removeItem("clientId");
		plus.storage.removeItem("userId");
		// plus.storage.removeItem("sessionId");
		plus.storage.removeItem("realName");
		plus.storage.removeItem("accountName");
		plus.storage.removeItem("accountType");
		plus.storage.removeItem("mobile");
		plus.storage.removeItem("workNumber");
		plus.storage.removeItem("email");
		plus.storage.removeItem("avatar");
		plus.storage.removeItem("post");

		plus.storage.removeItem("loginToken");

	}
};

//发送Ajax请求
global.sendAjax = function(url, method, sendData, successCallback, failureCallback, contentType, showLoading) {
	if(url.indexOf("http") < 0)
		url = this.service_url + url;
	if(showLoading == undefined)
		showLoading = true;

	//对url中文编码
	url = encodeURI(url);
	global.log("开始请求连接：" + url + "  " + method);
	global.log("请求参数为：" + JSON.stringify(sendData));

	contentType = contentType || "application/json";
	if("get" == method || "GET" == method) {
		contentType = "application/x-www-form-urlencoded";
	}
	var sessionId = global.userInfo.getSessionId();
	global.log("当前cookie：" + sessionId);
	var headers = {
		'Content-Type': 'application/json'
	};
	if(sessionId) {
		headers.Cookie = sessionId;
	}
	mui.ajax({
		url: url,
		dataType: 'json', //服务器返回json格式数据
		type: method, //请求方式
		async: false, //异步或者同步
		timeout: 30000, //10s超时时间
		contentType: contentType,
		headers: headers,
		xhrFields: {
			withCredentials: true
		},
		crossDomain: true,
		data: sendData,
		beforeSend: function() {
			if(showLoading) {
				plus.nativeUI.showWaiting("请求处理中，请稍候……");
			}
		},
		success: function(result, textStatus, xhr) {
			global.log("响应数据：" + JSON.stringify(result, null, 3));

			/**n
			 * 结果回调
			 */
			try {
				if(result && result.success) {
					if(successCallback)
						successCallback(result);
				} else {
					var code = result.code;

					if(failureCallback) {
						failureCallback(result);
					} else {
						if(!code || (code && code != "3020")) {
							plus.nativeUI.toast(result.message);
						}
					}

					if(code) {
						var loginType = (sendData || {}).loginType;
						if(code === "3020") {
							if(loginType != "token") {
								loginHelper.tokenLogin();
							} else {
								loginHelper.toLogin();
							}
						} else if(code === "4000") {
							if(loginType == "token") {
								loginHelper.toLogin();
							}
						}
					}
				}
			} catch(e) {
				global.log(e);
			}
		},
		error: function(xhr, type, errorThrown) {
			var error = "网络请求异常：" + type;
			if(type === "timeout") {
				error = "网络连接超时，请检查网络重试";
			}
			plus.nativeUI.toast(error);
			global.log(errorThrown);
		},
		complete: function() {
			plus.nativeUI.closeWaiting(); //关闭加载中
		}
	});

};

/**
 * 登陆辅助类
 */
var loginHelper = {};
loginHelper.fillClientInfo = function(json) {
	var appId = global.userInfo.getAppId();
	var clientId = global.userInfo.getClientId();
	var deviceToken = global.userInfo.getDeviceToken();
	if(!deviceToken || !appId || !clientId || clientId == 'null') {
		//从个推那里获得参数
		var vInfo = plus.push.getClientInfo();
		//		alert(JSON.stringify(vInfo));

		appId = vInfo.appid;
		clientId = vInfo.clientid || '';
		deviceToken = vInfo.token || '';

		// if(!clientId || clientId.length < 0) {
		// 	clientId = new Date().getTime().toString();
		// }
		global.userInfo.setAppId(appId);
		global.userInfo.setClientId(clientId);
		global.userInfo.setDeviceToken(deviceToken);

		if(!vInfo.clientid) {
			var t1 = window.setInterval(function() {
				var info = plus.push.getClientInfo();
				if(info.clientid) {
					global.userInfo.setAppId(info.appid);
					global.userInfo.setClientId(info.clientid);
					global.userInfo.setDeviceToken(info.token);
					window.clearInterval(t1);
				}
			}, 100);
		}
	}
	json.appId = appId;
	json.clientId = clientId;
	json.deviceType = mui.os.android ? 'android' : 'ios';
	json.imei = plus.device.imei || '';
	json.deviceToken = deviceToken || '';
};
loginHelper.setUrlParams = function(url, sendData) {
	for(var key in sendData) {
		var paramValue = sendData[key];
		var s = url.indexOf("?") > 0 ? "&" : "?";
		if(paramValue && paramValue.length > 0 && paramValue != " ") {
			url += s + key + "=" + paramValue;
		}
	}
	return url;
};
//账号登陆
loginHelper.accountLogin = function(sendData) {
	sendData = sendData || {};
	sendData.loginType = "account";
	loginHelper.fillClientInfo(sendData);
	global.userInfo.clear();

	var requestUrl = global.getRequestUrl("/login");
	requestUrl = this.setUrlParams(requestUrl, sendData);

	global.sendAjax(requestUrl, "post", null, function(result) {
		loginHelper.onSuccess(result);
	}, null, "application/x-www-form-urlencoded");

};
//快速登陆
loginHelper.quickLogin = function(sendData) {
	sendData = sendData || {};
	sendData.loginType = "mobile";
	loginHelper.fillClientInfo(sendData);
	global.userInfo.clear();

	var requestUrl = global.getRequestUrl("/quickLogin");
	requestUrl = this.setUrlParams(requestUrl, sendData);

	global.sendAjax(requestUrl, "post", sendData, function(result) {
		loginHelper.onSuccess(result);
	});
};

//自动Token登陆
loginHelper.tokenLogin = function(successCallback) {
	var sendData = {};
	sendData.loginType = "token";
	var loginToken = global.userInfo.getLoginToken();
	sendData.loginToken = loginToken;
	loginHelper.fillClientInfo(sendData);

	if(sendData.clientId && loginToken) {
		var requestUrl = global.getRequestUrl("/tokenLogin");
		requestUrl = this.setUrlParams(requestUrl, sendData);

		global.sendAjax(requestUrl, "post", {}, function(result) {
			loginHelper.saveUserInfo(result.data);
			if(successCallback)
				successCallback(result);
		}, function(result) {
			//跳转到登陆页面
			loginHelper.toLogin();
		}, "application/x-www-form-urlencoded", false);
	} else {
		loginHelper.toLogin();
	}

};

//登陆成功回调
loginHelper.onSuccess = function(result) {
	loginHelper.saveUserInfo(result.data);
	loginHelper.toMain();
};

//保存用户信息
loginHelper.saveUserInfo = function(data) {
	if(!data) return;

	var userInfo = global.userInfo;
	if(data.cookie) {
		userInfo.setSessionId(data.cookie.toString());
	}
	userInfo.setAccountName(data.accountName);
	userInfo.setAccountType(data.accountType);
	if(data.appLoginToken) {
		userInfo.setLoginToken(data.appLoginToken);
	}
	userInfo.setRealName(data.realName);
	userInfo.setUserId(data.userId);
	userInfo.setAvatar(data.avatar);

	userInfo.setPost(data.post);
	userInfo.setEmail(data.email);
	userInfo.setWorkNumber(data.workNumber);
	userInfo.setMobile(data.mobile);

	/**
	 * 保存权限信息
	 */
	var appPermissionList = data.appPermissionList;
	if(appPermissionList != null) {
		userInfo.clearAllPermission();
		for(var i = 0; i < appPermissionList.length; i++) {
			userInfo.setPermission(appPermissionList[i].code, "1");
		}
	}
};

loginHelper.toMain = function() {
	//跳转到首页
	var mainPage = plus.webview.getLaunchWebview();
	plus.storage.setItem("manualLogin", "true");
	mui.fire(mainPage, "subPageRefresh", {});
	plus.webview.show(mainPage);
};

//跳转到登陆页面
loginHelper.toLogin = function() {
	global.userInfo.clear();
	var referer = plus.storage.getItem("referer");
	plus.storage.removeItem("referer");
	//跳到登陆页面
	var loginUrl = "../login.html";
	if(referer === "main")
		loginUrl = "login.html";
	mui.openWindow({
		url: loginUrl,
		id: 'login',
		preload: true,
		show: {
			aniShow: 'pop-in'
		},
		styles: {
			popGesture: 'hide'
		}
	});

};

/***
 * mui 返回页面刷新处理
 */
mui.plusReady(function() {
	var primaryBack = mui.back;
	mui.back = function() {
		var parentView = plus.webview.currentWebview().opener();
		if(!parentView) {
			var parentViewId = plus.webview.currentWebview.parentViewId;
			parentView = plus.webview.getWebviewById(parentViewId);
		}
		if(parentView) {
			//			console.log("opener view id :" + parentView.id);
			try {
				mui.fire(parentView, 'pageRefresh');
			} catch(e) {
				global.log(e);
			}
		}
		primaryBack();
	}
});

/***
 * mui 返回页面刷新处理
 */
var appPermissionKeys = {

	"menu_employer_sign_in": "menu_employer_sign_in", //员工签到
	"menu_customer_entry": "menu_customer_entry", //客户录入
	"menu_customer_manage": "menu_customer_manage", //客户管理
	"menu_customer_detail": "menu_customer_detail", //客户操作——》客户详情
	"customer_action_convert_yxkh": "customer_action_convert_yxkh", //客户操作——》转为意向客户
	"customer_action_convert_qdkh": "customer_action_convert_qdkh", //客户操作——》转为弃单客户
	"customer_action_contract_entry": "customer_action_contract_entry", //客户操作——》合同录入
	"customer_action_scheme_upload": "customer_action_scheme_upload", //客户操作——》上传方案报价
	"customer_action_add_contact": "customer_action_add_contact", //客户操作——》联系记录
	"customer_action_apply_payment": "customer_action_apply_payment", //客户操作——》业务回款
	"customer_action_send_sms": "customer_action_send_sms", //客户操作——》发送短信
	"customer_action_send_transfer": "customer_action_send_transfer", //客户操作——》客户转移
	"customer_action_base_edit": "customer_action_base_edit", //客户操作——》客户编辑
	"customer_action_add_contact": "customer_action_add_contact", //客户操作——》客户跟进
	"customer_detail_base": "customer_detail_base", //客户详情——》基本信息
	"customer_detail_contact_log": "customer_detail_contact_log", //客户详情——》联系记录
	"customer_detail_scehme": "customer_detail_scehme", //客户详情——》方案报价
	"customer_detail_contract": "customer_detail_contract", //客户详情——》合同信息
	"customer_detail_contract_product": "customer_detail_contract_product", //客户详情——》合同产品
	"customer_detail_payment": "customer_detail_payment", //客户详情——》回款信息
	"customer_detail_progress": "customer_detail_progress", //客户详情——》工程进度
	"customer_detail_patrol": "customer_detail_patrol", //客户详情——》工程巡检
	"customer_detail_acceptance": "customer_detail_acceptance", //客户详情——》工程验收
	"customer_detail_maintenance": "customer_detail_maintenance", //客户详情——》售后记录
	"customer_detail_complaint": "customer_detail_complaint", //客户详情——》评价投诉
	"menu_share_pool": "menu_share_pool", //公海池
	"share_pool_action_assign": "share_pool_action_assign", //公海池客户操作
	"menu_business_link": "menu_business_link", //业务链
	"menu_quick_quote": "menu_quick_quote", //快速报价
	"menu_account_detail": "menu_account_detail", //账户明细
	"menu_my_outer": "menu_my_outer", //我的外联
	"menu_project_assign": "menu_project_assign", //工程派工
	"page_list_project_assigned": "page_list_project_assigned", //工程派工-》已派工
	"page_list_project_unassign": "page_list_project_unassign", //工程派工-》未派工
	"menu_project_progress": "menu_project_progress", //工程进度
	"page_list_progress_unstart": "page_list_progress_unstart", //工程进度-待开工
	"page_list_progress_under": "page_list_progress_under", //工程进度-施工中
	"page_list_progress_completed": "page_list_progress_completed", //工程进度-已完工
	"project_action_start_complate": "project_action_start_complate", //工程进度-开工/完工 详情》按钮
	"menu_project_protal": "menu_project_protal", //工程巡检
	"page_list_protal_unstart": "page_list_protal_unstart", //工程巡检-未巡检
	"page_list_protal_unrepair": "page_list_protal_unrepair", //工程巡检-待整改
	"page_list_protal_unconfirm": "page_list_protal_unconfirm", //工程巡检-待确认
	"page_list_protal_already": "page_list_protal_already", //工程巡检-已巡检
	"protal_action_add": "protal_action_add", //工程巡检-》新增
	"menu_project_acceptance": "menu_project_acceptance", //工程验收
	"page_list_acceptance_under": "page_list_acceptance_under", //工程验收-待验收
	"page_list_acceptance_already": "page_list_acceptance_already", //工程验收-已验收
	"menu_business_approve": "menu_business_approve", //业务审批
	"menu_payment_approve": "menu_payment_approve", //业务审批-回款审批
	"page_list_approve_payment_pending": "page_list_approve_payment_pending", //回款审批-待审批
	"page_list_approve_payment_already": "page_list_approve_payment_already", //回款审批-已审批
	"menu_contract_approve": "menu_contract_approve", //业务审批-合同审批
	"page_list_approve_contract_pending": "page_list_approve_contract_pending", //合同审批-待审批
	"page_lisg_approve_contract_already": "page_lisg_approve_contract_already", //合同审批-已审批
	"menu_acceptance_approve": "menu_acceptance_approve", //业务审批-验收审批
	"page_list_approve_acceptance_pending": "page_list_approve_acceptance_pending", //验收审批-待审批
	"page_list_approve_acceptance_already": "page_list_approve_acceptance_already", //验收审批-已审批
	"menu_indent_approve": "menu_indent_approve", //业务审批-订货审批
	"page_list_approve_indent_pending": "page_list_approve_indent_pending", //订货审批-待审批
	"page_list_approve_indent_already": "page_list_approve_indent_already", //订货审批-已审批
	"menu_purchase_approve": "menu_purchase_approve", //业务审批-采购审批
	"page_list_approve_purchase_pending": "page_list_approve_purchase_pending", //采购审批-待审批
	"page_list_approve_purchase_already": "page_list_approve_purchase_already", //采购审批-已审批
	"menu_boss_board": "menu_boss_board", //BOSS看板
	"menu_boss_board_sale": "menu_boss_board_sale", //BOSS看板-销售看板
	"menu_boss_board_project": "menu_boss_board_project", //BOSS看板-工程看板
	"menu_boss_board_complaint": "menu_boss_board_complaint", //BOSS看板-投诉看板
	"menu_maintain_manage": "menu_maintain_manage", //售后管理
	"menu_maintain_register": "menu_maintain_register", //售后管理-》售后登记
	"maintain_action_add": "maintain_action_add", //售后管理-》添加售后信息
	"maintain_detail_view": "maintain_detail_view", //售后管理-》售后详情
	"menu_maintain_assign": "menu_maintain_assign", //售后管理-》售后派工
	"page_list_maintain_unassign": "page_list_maintain_unassign", //售后派工-待派工
	"page_list_maintain_assigned": "page_list_maintain_assigned", //售后派工-已派工
	"maintain_action_worker_assign": "maintain_action_worker_assign", //售后派工-》派工按钮
	"menu_maintain_service": "menu_maintain_service", //售后管理-》售后服务
	"menu_diary_manage": "menu_diary_manage", //日志管理
	"menu_query_statistics": "menu_query_statistics", //查询统计
	"menu_interconnect_indent": "menu_interconnect_indent", //互联订货管理
	"menu_task_manage": "menu_task_manage",//任务管理
	"menu_project_register": "menu_project_register", //项目报备
	"menu_home_project_register": "menu_home_project_register", //家装报备
	"menu_tender_project_register": "menu_tender_project_register", //工程报备
	"menu_my_achievement": "menu_my_achievement", //我的业绩
	"menu_distribution_indent": "menu_distribution_indent", //分销订货管理
	"menu_invoice_apply": "menu_invoice_apply", //开票申请
	
	


};

var domUtils = {
	hide: function(selector) {
		var dom = document.querySelector(selector);
		if(dom) {
			dom.classList.add('mui-hidden');
		}
	},
	show: function(selector) {
		var dom = document.querySelector(selector);
		if(dom) {
			dom.classList.remove('mui-hidden');
		}
	}

};

var windowExtrusion = function() {
	if(!mui.os.android) return;
	//获取原始窗口的高度
	var originalHeight = document.documentElement.clientHeight || document.body.clientHeight;
	window.onresize = function() {
		//软键盘弹起与隐藏  都会引起窗口的高度发生变化
		var resizeHeight = document.documentElement.clientHeight || document.body.clientHeight;
		if(resizeHeight * 1 < originalHeight * 1) { //resizeHeight<originalHeight证明窗口被挤压了
			plus.webview.currentWebview().setStyle({
				height: originalHeight
			});
		}
	}
};