// 通用分页插件

// html模板如下：
//
//     <div id="refreshContainer" class="mui-content mui-scroll-wrapper" >
//         <div class="mui-scroll">
//             <!--数据列表-->
//             <ul class="mui-table-view mui-table-view-cell">
//                 <li class="mui-table-view-cell">
//                      <a href="" class="mui-navigate-right">Item 1</a>
//                 </li>
//             </ul>
//         </div>
//     </div>

;

function Pager() {
    var pager = {};
    pager.init = function (selector, dataUrl, urlMethod, renderFunction, sendData, permissionKey) {
        pager.selector = selector;
        pager.dataUrl = dataUrl;
        pager.method = urlMethod;
        pager.render = renderFunction;
        pager.permissionKey = permissionKey;

        var param = sendData || {};
        param.pageSize = 8;
        param.pageIndex = 0;
        pager.pageParam = param;

        if ((this.permissionKey && this.permissionKey.length > 0) && global.userInfo.hasPermission(this.permissionKey) == false) {

            var table = pager.selector[0];

            //更换为一个没有数据的背景样式
            table.innerHTML="<div style=\"height: 140px;margin-top: 50px;margin-bottom: 50px; vertical-align: middle; text-align: center;\" >\n" +
                "\t\t\t\t<img src=\"../images/no_authority.png\" style=\"width: 200px; height: 140px;\" />\n" +
                "\t\t\t</div>";
            
            return false;
        } else {
            pager.selector[0].querySelector('.mui-table-view').innerHTML = '';
            pager.selector.pullRefresh({
                up: {
                    // offset:'100px', //可选 默认0px,下拉刷新控件的起始位置
                    style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
                    contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
                    contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
                    auto: true, //可选,默认false.首次加载自动下拉刷新一次
                    callback: function () { //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
                        pager.pageParam.pageIndex += 1;
                        pager.getData(pager.pageParam, "up");
                    }
                }
                //             down: {
                //                 height: 50, //可选,默认50.触发下拉刷新拖动距离,
                //			     auto: true, //可选,默认false.首次加载自动下拉刷新一次
                //                 contentdown: "下拉可以刷新", //可选，在下拉可刷新状态时，下拉刷新控件上显示的标题内容
                //                 contentover: "释放立即刷新", //可选，在释放可刷新状态时，下拉刷新控件上显示的标题内容
                //                 contentrefresh: "正在刷新...", //可选，正在刷新状态时，下拉刷新控件上显示的标题内容
                //                 callback: function () { //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
                //                     pager.getData(pager.pageParam, "down");
                //                 }
                //             }
            });
        }
    };
    pager.getData = function (param, type) {
        global.sendAjax(global.service_url + pager.dataUrl, "get", param, function (result) {
            if (result.data && (result.data.length > 0 || (result.data.rows && result.data.rows.length > 0))) {
                var table = pager.selector[0].querySelector('.mui-table-view');
                var dom = document.createElement("div");
                // dom.className = 'mui-table-view-cell';
                var html = pager.render(result);
                dom.innerHTML = html;
                //                 console.log("newDom: " +dom.innerHTML);

                table.appendChild(dom);
                if (type == "up") {
                    pager.selector.pullRefresh().refresh(true);
                    pager.selector.pullRefresh().endPullupToRefresh(false);
                }
            } else {
                if (type == "up") {
                    pager.selector.pullRefresh().endPullupToRefresh(true);
                }
            }
            pager.selector.pullRefresh().endPulldownToRefresh(true);
        }, null, null, null, false);
    };

    return pager;
}